
package kosoft.testproxy;

//Copyright (C) 2000 Mark O'Donohue [ mark.odonohue@gmail.com] 
// All rights reserved.
//
//This library is free software; you can redistribute it and/or modify it under the terms of the GNU 
//Lesser General Public License as published by the Free Software Foundation; either version 2.1 of 
//the License, or (at your option) any later version.

//This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
//even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//Lesser General Public License for more details.


import java.util.ArrayList;
import java.util.HashMap;

public  class KeyListMap<KEY,OBJ> {
	HashMap<KEY, OBJ> map = new HashMap<KEY, OBJ>(); 
	ArrayList<KEY> list = new ArrayList<KEY>();
	
	public HashMap<KEY, OBJ> getMap() { return map; }
	public ArrayList<KEY> getList() { return list; }

	public void clear() { 
		map.clear();
		list.clear();
	}
	
	public OBJ remove(KEY key) {
		OBJ value = map.get(key);
		map.remove(key);
		list.remove(key);
		return value;
	}
	public OBJ get(KEY key) { return map.get(key); }
	
	public void put(KEY key, OBJ value) {
		list.add(key);
		map.put(key, value);
	}
	
	public String toString() { return map.toString(); } 
}
